#property indicator_chart_window //   
#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_color2 Aqua
#property indicator_color3 Blue
//-- 
extern string TimeFrame = "Current time frame";
extern double Step=0.02; //    
extern double Maximum=0.2; //  
extern bool   ExtremumsShift=1; //  : 0 -    ; 1 -     
extern int    History=0; // -  ; 0 - 
extern bool   SarOnFirstBar = true;

//--
double   Peak[], //  ZigZag  
         Trough[], //  ZigZag  
         SAR[]; //  Parabolic
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//=============================================================
int init()
  {
   SetIndexBuffer(0,Peak); // 
   SetIndexStyle(0,DRAW_ZIGZAG);
   SetIndexLabel(0,"Peak");
   SetIndexEmptyValue(0,0.0);

   SetIndexBuffer(1,Trough); // , .. )))
   SetIndexStyle(1,DRAW_ZIGZAG);
   SetIndexLabel(1,"Trough");
   SetIndexEmptyValue(1,0.0);

   SetIndexBuffer(2,SAR); // 
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   SetIndexLabel(2,"SAR");
   SetIndexEmptyValue(2,0.0);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+"  ZigZagOnParabolic");
     
   return(0);
  }

//=============================================================
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Peak[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               int shift = -1; if (SarOnFirstBar) shift=1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);   
                   int x = iBarShift(NULL,timeFrame,Time[i+shift]);            
                      Peak[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Step,Maximum,ExtremumsShift,History,0,y);
                      Trough[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Step,Maximum,ExtremumsShift,History,1,y);
               if (x!=y)
               {
                      SAR[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Step,Maximum,ExtremumsShift,History,2,y);
               }
             }
             return(0);
          }
   static int BarsPrev; //  Bars  .
   bool MissBars=Bars-BarsPrev>1; // 1 -   
   bool NewBar=Bars-BarsPrev==1; // 1 -    
   if(MissBars && BarsPrev!=0) BarsPrev=reinit(); //     -  
   
   limit=Bars-BarsPrev-(BarsPrev==0); BarsPrev=Bars; // - 
   if(History!=0 && limit>History) limit=History-1; // -   

   for(i=limit; i>=0; i--) //      
     {   
      SAR[i]=iSAR(NULL,0,Step,Maximum, i); // 
      double mid[2]; // . 
      mid[0]=(High[i]+Low[i])/2; // .   
      mid[1]=(High[i+1]+Low[i+1])/2; // .  .

      static int j; //           
      static bool dir; //  ; 0 - , 1 - 
      static double h,l; //   

      if(i>0) j++; //   ,    
      if(dir) //   
        {
         if(h<High[i]) {h=High[i]; j=NewBar;} //  ;   
         if(SAR[i+1]<=mid[1] && SAR[i]>mid[0]) //   
           {
            shift=i+ExtremumsShift*(j+NewBar); // 
            Peak[shift]=h; // 
            dir=0; //  
            l=Low[i]; j=0; //  ,   
           }
        }
      else //  
        {
         if(l>Low[i]) {l=Low[i]; j=NewBar;} //  ;   
         if(SAR[i+1]>=mid[1] && SAR[i]<mid[0]) //   
           {
            shift=i+ExtremumsShift*(j+NewBar); // 
            Trough[shift]=l; // 
            dir=1; //  
            h=High[i]; j=0; //  ,   
           }
        }
     }

//   if(MissBars) Print("limit: ",limit," Bars:",Bars," IndicatorCounted: ",IndicatorCounted());

   return(0);
  }
//=============================================================

// -  
int reinit()
  {
   ArrayInitialize(Peak,0.0);
   ArrayInitialize(Trough,0.0);
   ArrayInitialize(SAR,0.0);
   return(0);
  }
  
  //-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

 